/**
 * Namespaces or tools therefor.
 * @module namespaces
 * @license MIT
*/
const e="http://www.w3.org/1999/xhtml",t="http://www.w3.org/2000/svg",a=["r","radius","x","x1","cx","rx","width","y","y1","cy","ry","height"];
/**
 * Tools for working with units.
 * @module units
 * @license MIT
 *
 * @copyright 2010 Alexis Deveria, 2010 Jeff Schiller
 */let n={};const isValidUnit=function(e,t,i){if(a.includes(e))return!isNaN(t)||(t=t.toLowerCase(),Object.keys(n).some((e=>new RegExp("^-?[\\d\\.]+"+e+"$").test(t))));if("id"===e){let e=!1;try{const a=undefined.getElement(t);e=!a||a===i}catch(e){}return e}return!0},i="http://www.w3.org/2000/svg",o="http://www.w3.org/1999/xlink";
/**
 * Namespaces or tools therefor.
 * @module namespaces
 * @license MIT
*/
/**
 * Mathematical utilities.
 * @module math
 * @license MIT
 *
 * @copyright 2010 Alexis Deveria, 2010 Jeff Schiller
 */
document.createElementNS(i,"svg");
/**
 * Browser detection.
 * @module browser
 * @license MIT
 *
 * @copyright 2010 Jeff Schiller, 2010 Alexis Deveria
 */
const r="http://www.w3.org/2000/svg",{userAgent:l}=navigator;l.includes("AppleWebKit"),l.includes("Gecko/"),l.includes("Chrome/"),l.includes("Macintosh"),function(){const e=document.createElementNS(r,"svg"),t=document.createElementNS(r,"svg");document.documentElement.append(e),t.setAttribute("x",5),e.append(t);const a=document.createElementNS(r,"text");a.textContent="a",t.append(a);try{a.getStartPositionOfChar(0).x}catch(e){return!1}finally{e.remove()}}(),function(){const e=document.createElementNS(r,"svg");document.documentElement.append(e);const t=document.createElementNS(r,"path");t.setAttribute("d","M0,0 10,0");const a=document.createElementNS(r,"path");a.setAttribute("d","M5,0 15,0");const n=document.createElementNS(r,"g");n.append(t,a),e.append(n);const i=n.getBBox();e.remove(),i.width}(),function(){const e=document.createElementNS(r,"rect");e.setAttribute("style","vector-effect:non-scaling-stroke"),e.style.vectorEffect}();!function(){if("undefined"==typeof Blob)return"";(function(e){e&&"undefined"!=typeof URL&&URL.createObjectURL&&URL.createObjectURL(e)})(new Blob(["<html><head><title>SVG-edit</title></head><body>&nbsp;</body></html>"],{type:"text/html"}))}();let getHref=function(e){return e.getAttributeNS(o,"href")},setHref=function(e,t){e.setAttributeNS(o,"xlink:href",t)};let getRotationAngle=function(e,t){var a;return((e,t)=>{if(!e)return 0;for(let a=0;a<e.numberOfItems;++a){const n=e.getItem(a);if(4===n.type)return t?n.angle*Math.PI/180:n.angle}return 0})(null===(a=(e||null.getSelectedElements()[0]).transform)||void 0===a?void 0:a.baseVal,t)};const isNullish=e=>null==e,s={BEFORE_APPLY:"before_apply",AFTER_APPLY:"after_apply",BEFORE_UNAPPLY:"before_unapply",AFTER_UNAPPLY:"after_unapply"};class Command{getText(){return this.text}apply(e,t){e&&e.handleHistoryEvent(s.BEFORE_APPLY,this),t(e),e&&e.handleHistoryEvent(s.AFTER_APPLY,this)}unapply(e,t){e&&e.handleHistoryEvent(s.BEFORE_UNAPPLY,this),t(),e&&e.handleHistoryEvent(s.AFTER_UNAPPLY,this)}elements(){return[this.elem]}type(){return this.constructor.name}}class ChangeElementCommand extends Command{constructor(e,t,a){super(),this.elem=e,this.text=a?"Change "+e.tagName+" "+a:"Change "+e.tagName,this.newValues={},this.oldValues=t;for(const a in t)this.newValues[a]="#text"===a?e?e.textContent:"":"#href"===a?getHref(e):e.getAttribute(a)}apply(e){super.apply(e,(()=>{let e=!1;if(Object.entries(this.newValues).forEach((([t,a])=>{a?"#text"===t?this.elem.textContent=a:"#href"===t?setHref(this.elem,a):this.elem.setAttribute(t,a):"#text"===t?this.elem.textContent="":(this.elem.setAttribute(t,""),this.elem.removeAttribute(t)),"transform"===t&&(e=!0)})),!e){const e=getRotationAngle(this.elem);if(e){const t=this.elem.getBBox(),a=["rotate(",e," ",t.x+t.width/2,",",t.y+t.height/2,")"].join("");a!==this.elem.getAttribute("transform")&&this.elem.setAttribute("transform",a)}}}))}unapply(e){super.unapply(e,(()=>{let e=!1;if(Object.entries(this.oldValues).forEach((([t,a])=>{a?"#text"===t?this.elem.textContent=a:"#href"===t?setHref(this.elem,a):this.elem.setAttribute(t,a):"#text"===t?this.elem.textContent="":this.elem.removeAttribute(t),"transform"===t&&(e=!0)})),!e){const e=getRotationAngle(this.elem);if(e){const t=this.elem.getBBox(),a=["rotate(",e," ",t.x+t.width/2,",",t.y+t.height/2,")"].join("");a!==this.elem.getAttribute("transform")&&this.elem.setAttribute("transform",a)}}}))}}class BatchCommand$1 extends Command{constructor(e){super(),this.text=e||"Batch Command",this.stack=[]}apply(e){super.apply(e,(()=>{this.stack.forEach((t=>{console.assert(t,"stack item should not be null"),t&&t.apply(e)}))}))}unapply(e){super.unapply(e,(()=>{this.stack.reverse().forEach((t=>{console.assert(t,"stack item should not be null"),t&&t.unapply(e)}))}))}elements(){const e=[];let t=this.stack.length;for(;t--;){if(!this.stack[t])continue;const a=this.stack[t].elements();let n=a.length;for(;n--;)e.includes(a[n])||e.push(a[n])}return e}addSubCommand(e){console.assert(null!==e,"cmd should not be null"),this.stack.push(e)}isEmpty(){return!this.stack.length}}var d=Object.freeze({__proto__:null,HistoryEventTypes:s,Command:Command,MoveElementCommand:class MoveElementCommand extends Command{constructor(e,t,a,n){super(),this.elem=e,this.text=n?"Move "+e.tagName+" to "+n:"Move "+e.tagName,this.oldNextSibling=t,this.oldParent=a,this.newNextSibling=e.nextSibling,this.newParent=e.parentNode}apply(e){super.apply(e,(()=>{this.elem=this.newParent.insertBefore(this.elem,this.newNextSibling)}))}unapply(e){super.unapply(e,(()=>{this.elem=this.oldParent.insertBefore(this.elem,this.oldNextSibling)}))}},InsertElementCommand:class InsertElementCommand$1 extends Command{constructor(e,t){super(),this.elem=e,this.text=t||"Create "+e.tagName,this.parent=e.parentNode,this.nextSibling=this.elem.nextSibling}apply(e){super.apply(e,(()=>{this.elem=this.parent.insertBefore(this.elem,this.nextSibling)}))}unapply(e){super.unapply(e,(()=>{this.parent=this.elem.parentNode,this.elem.remove()}))}},RemoveElementCommand:class RemoveElementCommand extends Command{constructor(e,t,a,n){super(),this.elem=e,this.text=n||"Delete "+e.tagName,this.nextSibling=t,this.parent=a}apply(e){super.apply(e,(()=>{this.parent=this.elem.parentNode,this.elem.remove()}))}unapply(e){super.unapply(e,(()=>{isNullish(this.nextSibling)&&window.console&&console.error("Reference element was lost"),this.parent.insertBefore(this.elem,this.nextSibling)}))}},ChangeElementCommand:ChangeElementCommand,BatchCommand:BatchCommand$1,UndoManager:class UndoManager$1{constructor(e){this.handler_=e||null,this.undoStackPointer=0,this.undoStack=[],this.undoChangeStackPointer=-1,this.undoableChangeStack=[]}resetUndoStack(){this.undoStack=[],this.undoStackPointer=0}getUndoStackSize(){return this.undoStackPointer}getRedoStackSize(){return this.undoStack.length-this.undoStackPointer}getNextUndoCommandText(){return this.undoStackPointer>0?this.undoStack[this.undoStackPointer-1].getText():""}getNextRedoCommandText(){return this.undoStackPointer<this.undoStack.length?this.undoStack[this.undoStackPointer].getText():""}undo(){if(this.undoStackPointer>0){this.undoStack[--this.undoStackPointer].unapply(this.handler_)}}redo(){if(this.undoStackPointer<this.undoStack.length&&this.undoStack.length>0){this.undoStack[this.undoStackPointer++].apply(this.handler_)}}addCommandToHistory(e){this.undoStackPointer<this.undoStack.length&&this.undoStack.length>0&&(this.undoStack=this.undoStack.splice(0,this.undoStackPointer)),this.undoStack.push(e),this.undoStackPointer=this.undoStack.length}beginUndoableChange(e,t){const a=++this.undoChangeStackPointer;let n=t.length;const i=new Array(n),o=new Array(n);for(;n--;){const a=t[n];isNullish(a)||(o[n]=a,i[n]=a.getAttribute(e))}this.undoableChangeStack[a]={attrName:e,oldValues:i,elements:o}}finishUndoableChange(){const e=this.undoChangeStackPointer--,t=this.undoableChangeStack[e],{attrName:a}=t,n=new BatchCommand$1("Change "+a);let i=t.elements.length;for(;i--;){const e=t.elements[i];if(isNullish(e))continue;const o={};o[a]=t.oldValues[i],o[a]!==e.getAttribute(a)&&n.addSubCommand(new ChangeElementCommand(e,o,a))}return this.undoableChangeStack[e]=null,n}}});const{InsertElementCommand:c,BatchCommand:u,UndoManager:f}=d,m="svgedit.plotly.local"==location.hostname?"https://plotly.local/":"https://"+location.hostname+"/";
/**
 * @file ext-figlinq.js
 * @license MIT
 * @copyright 2021 figlinq.com
 */var p={name:"figlinq",async init(){const a=this,{svgCanvas:n}=a;return{name:a.i18next.t("figlinq:name"),callback(){document.querySelector("#se-cmenu_canvas").shadowRoot.querySelector(".contextMenu").setAttribute("style","min-width:250px;"),jQuery(document).keydown((function(e){e.originalEvent.ctrlKey&&!e.originalEvent.shiftKey&&90==e.originalEvent.keyCode?clickUndo():(e.originalEvent.ctrlKey&&e.originalEvent.shiftKey&&90==e.originalEvent.keyCode||e.originalEvent.ctrlKey&&89==e.originalEvent.keyCode||e.originalEvent.ctrlKey&&89==e.originalEvent.keyCode)&&clickRedo()})),jQuery(window).bind("mousewheel DOMMouseScroll",(function(e){if(1==e.ctrlKey)return e.preventDefault(),showZoomWarning(),!1})),jQuery(".modal").bind("mousewheel DOMMouseScroll",(function(e){if(1==e.ctrlKey)return e.preventDefault(),!1}));var i,o,r,l,s,d,f,p,h,g,y,v=!1,j=!1,b="my",Q={my:!1,shared:!1,preselected:!1},q=15,C=15,w=15,x=15,k=5,S=10;const E={A0:"2383.94x3370.39",A1:"1683.78x2383.94",A2:"1190.55x1683.78",A3:"841.89x1190.55",A4:"595.28x841.89",A5:"419.53x595.28",Letter:"612.00x792.00"},_={"1x (current)":1,"2x":2,"3x":3,"4x":4,"6x":6,"8x":8},P="http://www.w3.org/2000/svg",O=["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"],setDeep=function(e,t,a,n=!1){t.reduce(((e,i,o)=>n&&void 0===e[i]&&o!==t.length?(e[i]={},e[i]):o===t.length-1?(e[i]=a,a):e[i]),e)},showZoomWarning=()=>{jQuery("#fq-modal-warning-zoom").addClass("is-active"),setTimeout((function(){jQuery("#fq-modal-warning-zoom").removeClass("is-active")}),1250)},setInteractiveOff=()=>{jQuery("#fq-menu-interact-switch").prop("checked",!1);jQuery("svg[class='fq-fobj-container']").each((function(){var e=jQuery(this).data("ref_id");jQuery("#"+e).attr("visibility","visible"),this.remove()}))},setInteractiveOn=()=>{n.clearSelection();var e,t;jQuery(".fq-plot").each((function(){e=jQuery(this),t=generateForeignObject(e),n.addSVGElementFromJson(t),this.setAttribute("visibility","hidden")}))},updateBreadcrumb=(e,t)=>{var a=!1;jQuery(".breadcrumb-item").each((function(){jQuery(this).data("fid")==e&&(a=!0)})),a?jQuery(jQuery(".breadcrumb-item").get().reverse()).each((function(){if(jQuery(this).data("fid")==e)return!1;jQuery(this).remove()})):t?jQuery(function breadcrumb(e,t){return-1==(e.includes(":")?e.substring(e.indexOf(":")+1):e)?`<li>\n                <div class="fq-modal-folder-item" data-fid="${e}">\n                    <span class="icon">\n                        <i class="fas fa-home"></i>\n                    </span>&nbsp;\n                </div>\n            </li>`:`<li class="breadcrumb-item" data-fid="${e}">\n                <a href="#" class="fq-modal-folder-item" data-fid="${e}">${t}</a>\n            </li>`}(e,t)).insertAfter(".breadcrumb-item:last"):jQuery(".breadcrumb-item:not(#fq-breadcrumb-item-home)").remove()},F=function getUrlParameter(e){var t,a,n=window.location.search.substring(1).split("&");for(a=0;a<n.length;a++)if((t=n[a].split("="))[0]===e)return void 0===typeof t[1]||decodeURIComponent(t[1]);return!1},parseFid=(e,t=1)=>!(!e||!e.includes(":"))&&e.split(":")[t],getFileDataFromFiglinQ=(e,t="files")=>{const a=`${m}v2/${t}/${e}`;return new Promise((t=>{jQuery.ajax({url:a,xhrFields:{withCredentials:!0}}).done((function(e){t(e)})).fail((function(a){t({fid:e,error:a.responseJSON.detail})}))}))},updateItemList=(e,t,a=!1)=>{if(Array.isArray(e)){var n=[];e.forEach((e=>{n.push({fid:e,endpoint:"files"})}));var i=n.map((function(e){return getFileDataFromFiglinQ(e.fid,e.endpoint)}));return void Promise.all(i).then((t=>{var a={children:{results:t,next:null}};v={data:a,fids:e},jQuery(".fq-modal-file-tab").removeClass("is-active"),jQuery("#fq-modal-file-tab-preselected").removeClass("is-hidden"),jQuery("#fq-modal-file-tab-preselected").addClass("is-active"),populateFileModal(a)}))}const o=parseFid(e);var r;"my"==b?r=a?`${m}v2/folders/all?s=${a}&filetype=plot&filetype=external_image&page_size=1000`:`${m}v2/folders/${e}?page=${t}&${"upload"==l?"filetype=fold":"filetype=plot&filetype=fold&filetype=external_image"}&order_by=filename&page_size=1000`:"shared"==b&&(r=-1==o?`${m}v2/folders/shared?filetype=fold&filetype=plot&filetype=external_image&order_by=filename&page_size=1000`:`${m}v2/folders/${e}?page=${t}&filetype=fold&filetype=plot&filetype=external_image&order_by=filename&page_size=1000`),jQuery.ajax({url:r,xhrFields:{withCredentials:!0}}).done(populateFileModal).fail((function(){showToast("Communication error, file list has not been updated","is-danger")})).always((function(){}))},populateFileModal=(e,t=!1)=>{jQuery("#fq-modal-files-open-figure-confirm").prop("disabled",!0),jQuery("#fq-modal-save-name-input").val().length?jQuery("#fq-modal-save-confirm-btn").prop("disabled",!1):jQuery("#fq-modal-save-confirm-btn").prop("disabled",!0);var a=0,n=e.children.results;n.forEach((e=>{const t="svgedit"in e.metadata,n="addContent"===l||"upload"===l;if("fold"!==e.filetype||e.deleted)if(t&&"external_image"===e.filetype&&!e.deleted){var r=!1;"addContent"===l&&e.hasOwnProperty("metadata")&&e.metadata.hasOwnProperty("svgedit")&&e.metadata.svgedit.hasOwnProperty("haslinkedcontent")&&!0===e.metadata.svgedit.haslinkedcontent&&(r=!0),o+=function figureItem(e,t,a,n=!1){return`\n    <a class="is-relative panel-block panel-list-item fq-modal-figure-item noselect is-size-7 ${n?"is-disabled":""}" data-ftype="figure" data-fid="${t}" data-index="${a}">\n        <span class="panel-icon fa-stack">\n            <i class="fas fa-shapes fa-stack-1x"></i>\n            <i class="far fa-square fa-stack-2x"></i>\n        </span>\n        <span class="fq-list-item-text">${e}</span>\n        ${n?'<span class="fq-list-item-text panel-list-explanation"><i class="fas fa-exclamation-triangle mr-2"></i>Figure with linked content cannot be added to another figure.</span>':""}\n    </a>`}(e.filename,e.fid,a,r),a+=1}else!n||t||"external_image"!==e.filetype||e.deleted?n&&"plot"===e.filetype&&!e.deleted?(o+=function plotItem(e,t,a){return`\n    <a class="is-relative panel-block panel-list-item fq-modal-image-item noselect is-size-7" data-ftype="plot" data-fid="${t}" data-index="${a}">\n        <span class="panel-icon">\n            <i class="fas fa-chart-bar" aria-hidden="true"></i>\n        </span>\n        <span class="fq-list-item-text">${e}</span>\n    </a>`}(e.filename,e.fid,a),a+=1):"error"in e&&showToast(`Error loading file ${e.fid} - ${e.error}.`,"is-danger"):(o+=function imageItem(e,t,a){return`\n    <a class="is-relative panel-block panel-list-item fq-modal-image-item noselect is-size-7" data-ftype="image" data-fid="${t}" data-index="${a}">\n        <span class="panel-icon">\n            <i class="fas fa-image" aria-hidden="true"></i>\n        </span>\n        <span class="fq-list-item-text">${e}</span>\n    </a>`}(e.filename,e.fid,a),a+=1);else i+=function folderItem(e,t){return`\n    <a class="is-relative panel-block panel-list-item fq-modal-folder-item noselect is-size-7" data-fid="${t}">\n        <span class="panel-icon has-text-black">\n            <i class="fas fa-folder-open" aria-hidden="true"></i>\n        </span>${e}</a>`}(e.filename,e.fid)})),null==e.children.next?(jQuery(".panel-list-item").remove(),jQuery("#fq-modal-item-list-container").html(i+o),jQuery("#fq-modal-refresh-btn").removeClass("is-loading")):(page+=1,updateItemList(dataFid,page));var r=1==n.length?"item":"items";jQuery("#fq-modal-file-search-items-found").text(n.length+" "+r+" found"),v&&"preselected"===b&&v.fids.forEach((e=>{jQuery("*[data-fid='"+e+"']").hasClass("is-disabled")||jQuery("*[data-fid='"+e+"']").addClass("is-active"),jQuery("#fq-modal-add-confirm-btn").prop("disabled",!1)})),hideModalSpinner()},generateForeignObject=a=>{const i=a.attr("href"),o=decodeURIComponent(a.data("content_href")),r=i.replace(".svg",".embed"),l=null==o?r:o,s=a.attr("height"),d=a.attr("width"),c=a.attr("x"),u=a.attr("y"),f=a.attr("id"),m=a.data("original_dimensions").split(","),p=a.data("fid");let h={element:"iframe",namespace:e,attr:{x:0,y:0,width:m[0],height:m[1],id:n.getNextId(),src:l,xmlns:e,allow:"fullscreen"}},g={element:"body",namespace:e,attr:{id:n.getNextId(),xmlns:e},children:[h]},y={element:"foreignObject",namespace:t,attr:{x:0,y:0,width:m[0],height:m[1],id:n.getNextId(),xmlns:t},children:[g]};return{element:"svg",namespace:t,attr:{x:c,y:u,width:d,height:s,viewBox:`0 0 ${m[0]} ${m[1]}`,preserveAspectRatio:"none",id:n.getNextId(),class:"fq-fobj-container","data-ref_id":f,"data-fid":p,xmlns:t},children:[y]}},placeElement=e=>{var a={xmlns:t,preserveAspectRatio:"none",id:n.getNextId(),style:"pointer-events:inherit",class:"fq-"+e.filetype,href:e.imgHref,width:e.width,height:e.height,x:e.x,y:e.y,"data-original_dimensions":`${e.widthOriginal},${e.heightOriginal}`,"data-fid":e.fid};"plot"==e.filetype&&(a["data-content_href"]=e.contentHref);const i={element:"image",namespace:t,attr:a},o=new u("Insert plot"),r=n.addSVGElementFromJson(i);o.addSubCommand(new c(r)),n.undoMgr.addCommandToHistory(o),n.call("changed",[r])},getSvgFromEditor=()=>{n.clearSelection();var e=!1;const t=a.configObj.curConfig.baseUnit;"px"!==t&&(e=!0,a.configObj.curConfig.baseUnit="px",n.setConfig(a.configObj.curConfig),a.updateCanvas());const i={images:a.configObj.pref("img_save"),round_digits:6,apply:!0},o=n.mergeDeep(n.getSvgOption(),i);for(const[e,t]of Object.entries(o))n.setSvgOption(e,t);const r='<?xml version="1.0"?>'+n.svgCanvasToString();return"px"!==t&&e&&(a.configObj.curConfig.baseUnit=t,n.setConfig(a.configObj.curConfig),a.updateCanvas()),r},showToast=(e,t)=>{const a="is-danger"===t?1e4:4e3;bulmaToast.toast({message:e,type:t,position:"bottom-right",closeOnClick:!0,dismissible:!0,duration:a})},closeModalOnEscape=e=>{"Escape"===e.key&&(jQuery("#fq-modal-file").removeClass("is-active"),jQuery(document).unbind("keyup",closeModalOnEscape))},refreshModalContents=(e=!1)=>{i="",o="",jQuery("#fq-modal-file").addClass("is-active"),jQuery(document).keyup(closeModalOnEscape);let t=jQuery("#fq-modal-file-search-input").val();t&&"my"==b?(jQuery("#fq-modal-file-search-icon").removeClass("fas fa-search"),jQuery("#fq-modal-file-search-icon").addClass("far fa-times-circle")):(jQuery("#fq-modal-file-search-icon").removeClass("far fa-times-circle"),jQuery("#fq-modal-file-search-icon").addClass("fas fa-search")),t=t.length>=2&&t,e?updateItemList(e,1,t):t&&"my"==b?(jQuery("#fq-modal-file-search-title").removeClass("is-hidden"),jQuery("#fq-modal-file-panel-breadcrumb").addClass("is-hidden"),updateItemList("shared",1,t)):(jQuery("#fq-modal-file-search-title").addClass("is-hidden"),jQuery("#fq-modal-file-panel-breadcrumb").removeClass("is-hidden"),Q[b]||(Q[b]="my"==b?r+":-1":"shared:-1"),updateItemList(Q[b],1)),updateBreadcrumb(Q[b],!1)},clickUndo=function(){const{undoMgr:e,textActions:t}=n;e.getUndoStackSize()>0&&(e.undo(),a.layersPanel.populateLayers(),"textedit"===a.svgCanvas.getMode()&&t.clear())},clickRedo=function(){const{undoMgr:e}=n;e.getRedoStackSize()>0&&(e.redo(),a.layersPanel.populateLayers())},onConfirmClear=async function(){jQuery("#fq-modal-confirm").removeClass("is-active");var e=new URL(document.location);e.searchParams.delete("fid"),window.history.pushState(null,null,e.href),j=!1;const[t,n]=a.configObj.curConfig.dimensions;a.leftPanel.clickSelect(),a.svgCanvas.clear(),a.svgCanvas.setResolution(t,n),a.updateCanvas(!0),a.zoomImage(),a.layersPanel.populateLayers(),a.topPanel.updateContextPanel(),a.svgCanvas.runExtensions("onNewDocument"),setTimeout((function(){a.zoomChanged(window,"canvas")}),300)},openFigure=async function(e){var t=m+"v2/external-images/"+e.data.fid;jQuery.ajax({url:t,xhrFields:{withCredentials:!0}}).done((function(e){if(!1 in e||"image/svg"!=e.content_type&&"image/svg+xml"!=e.content_type)showToast("This file type is not supported","is-danger");else{var t=function(e){var t,a,n,i={},o=0,r=0,l="",s=String.fromCharCode,d=e.length;for(t=0;t<64;t++)i["ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(t)]=t;for(a=0;a<d;a++)for(o=(o<<6)+i[e.charAt(a)],r+=6;r>=8;)((n=o>>>(r-=8)&255)||a<d-2)&&(l+=s(n));return l}(e.image_content.split(",")[1]);a.loadSvgString(t),jQuery("#fq-modal-confirm").removeClass("is-active"),("string"==typeof(j=e).metadata||j.metadata instanceof String)&&(j.metadata=JSON.parse(j.metadata)),setTimeout((function(){a.zoomChanged(window,"canvas")}),250),showToast('File "'+e.filename+'" loaded',"is-success");var n=new URL(document.location);n.searchParams.set("fid",e.fid),window.history.pushState(null,null,decodeURIComponent(n.href))}})).fail((function(e){showToast("This file could not be loaded","is-danger")}))},inlineRasterImage=async function(e){var t=jQuery("#"+e).attr("href");let a=await fetch(t,{method:"GET",mode:"cors",credentials:"include",headers:{"X-CSRFToken":s}}).then((async e=>({blob:await e.blob(),type:e.headers.get("Content-Type")}))),n=await new Promise((e=>{let t=new FileReader;t.onload=()=>e(t.result),t.readAsDataURL(a.blob)}));jQuery("#"+e).attr("href",n)},inlineSvgImage=async function(e){var t=jQuery("#fq-svg-container").find("#"+e).attr("href");await fetch(t,{method:"GET",mode:"cors",credentials:"include"}).then((e=>e.text())).then((t=>{var a=jQuery("#fq-svg-container").find("#"+e),n=(new DOMParser).parseFromString(t,"application/xml"),i=jQuery(n.documentElement).replaceAll(a);jQuery(i).attr("id",e)}))},svgToRaster=e=>new Promise((t=>{const a=document.getElementById("fq-canvas"),i=n.getResolution();var o,r;"thumb"===g?(o=1200,r=Math.round(1200*i.h/i.w)):(o=i.w*parseInt(p),r=i.h*parseInt(p)),a.width=o,a.height=r;var l=new Blob([e],{type:"image/svg+xml"}),s=window.URL||window.webkitURL||window,c=new Image,u=s.createObjectURL(l);c.onload=function(){const e=a.getContext("2d");if("png"!=d&&(e.fillStyle="white",e.fillRect(0,0,o,r)),e.drawImage(c,0,0,o,r),s.revokeObjectURL(u),"thumb"!==g){if("download"===g)var n=a.toDataURL("image/"+d,f).replace("image/"+d,"octet/stream");var i=document.createElement("a");document.body.appendChild(i),i.style="display: none",i.href=n,i.download=h+"."+d,i.click(),window.URL.revokeObjectURL(n),document.body.removeChild(i)}else a.toBlob((function(e){t(e)}))},c.src=u})),updateExportFormSizeSelect=e=>{jQuery("#fq-modal-export-size-select").find("option").remove(),jQuery.each(e,(function(e,t){jQuery("#fq-modal-export-size-select").append(jQuery("<option></option>").attr("value",t).text(e))}))},updateExportFormState=()=>{let e=jQuery("#fq-modal-export-format-select").val();"jpeg"===e?(jQuery('[id^="fq-modal-export-quality"]').prop("disabled",!1),jQuery('[id^="fq-modal-export-size"]').prop("disabled",!1),updateExportFormSizeSelect(_),jQuery("#fq-modal-export-size-select").val(1)):"png"===e||"bmp"===e?(jQuery('[id^="fq-modal-export-quality"]').prop("disabled",!0),updateExportFormSizeSelect(_),jQuery("#fq-modal-export-size-select").val(1)):(jQuery('[id^="fq-modal-export-quality"]').prop("disabled",!0),updateExportFormSizeSelect(E),jQuery("#fq-modal-export-size-select").val(E.A4))},exportImageFromEditor=async()=>{var e=n.svgCanvasToString(),t=(new DOMParser).parseFromString(e,"application/xml");jQuery("#fq-svg-container").append(t.documentElement);var a,i,o=jQuery("#fq-svg-container").find(".fq-image, .fq-plot"),r=[],l=[],s={};if(o.length){var c;jQuery(o).each((function(){var e,t;a=jQuery(this).attr("id"),i="__"+a,jQuery(this).attr("id",i),s[i]=(e=jQuery(this),t={},jQuery.each(e[0].attributes,(function(e,a){t[a.name]=a.value})),t),jQuery(this).hasClass("fq-image")?r.push(i):jQuery(this).hasClass("fq-plot")&&l.push(i)})),r.length&&await async function(e){for(const t of e)await inlineRasterImage(t)}(r),l.length&&await async function(e){for(const t of e)await inlineSvgImage(t)}(l);for(const e in s){var u=jQuery("#"+e).hasClass("fq-image");c=s[e];for(const t in c)"href"==t&&u||jQuery("#"+e).attr(t,c[t])}}var f=document.getElementById("fq-svg-container").firstChild,m=(new XMLSerializer).serializeToString(f);if(jQuery("#fq-svg-container").empty(),"pdf"===d)(e=>{const t=jQuery("#fq-modal-export-size-select").val().split("x"),a=new PDFDocument({size:p}),n=[];a.pipe({write:e=>n.push(e),end:()=>{const e=new Blob(n,{type:"application/octet-stream"});var t=window.URL.createObjectURL(e),a=document.createElement("a");document.body.appendChild(a),a.style="display: none",a.href=t,a.download=h+".pdf",a.click(),window.URL.revokeObjectURL(t),document.body.removeChild(a)},on:(e,t)=>{},once:(...e)=>{},emit:(...e)=>{}}),SVGtoPDF(a,e,0,0,{width:t[0],height:t[1],preserveAspectRatio:"xMinYMin meet"}),a.end()})(m);else if("download"===g)svgToRaster(m);else if("thumb"===g){return await svgToRaster(m)}},setModalConfirmBtnHandler=(e,t=null)=>{jQuery("#fq-modal-confirm-btn-ok").unbind("click",onConfirmClear),jQuery("#fq-modal-confirm-btn-ok").unbind("click",openFigure),jQuery("#fq-modal-confirm-btn-ok").on("click",t,e)},uploadFileToFiglinQ=(e,t,a,n,l)=>{let d,c,u;"upload"===g?(d=h,c=" uploaded",u=" uploaded"):(d=h,c=" saved",u=" saved");var f={"X-File-Name":d,"Plotly-World-Readable":a,"X-CSRFToken":s};const p=parseFid(l,0),y=parseFid(l,1);p!==r?(f["Target-Fid"]=l,f["Plotly-Parent"]=-1):f["Plotly-Parent"]=y,jQuery.ajax({method:"POST",url:m+"v2/external-images/"+t,xhrFields:{withCredentials:!0},headers:f,data:e,processData:!1,contentType:!1}).done((function(e){if(n)if(jQuery("#fq-modal-refresh-btn").addClass("is-loading"),i="",o="","upload"===g){const a=parseFid(e.file.fid,0),n=parseFid(e.file.fid,1),i=`${m}~${a}/${n}.`,o="plot"===e.file.filetype?"svg":"src";var t={width:e.file.metadata.width,height:e.file.metadata.height,widthOriginal:e.file.metadata.width,heightOriginal:e.file.metadata.height,x:0,y:0,filetype:getSvgeditFiletype(e.file.filetype),fid:e.file.fid,contentHref:i+"embed",imgHref:i+o};placeElement(t)}else{jQuery("#fq-modal-file").removeClass("is-active"),jQuery(document).unbind("keyup",closeModalOnEscape);var a=new URL(document.location);a.searchParams.set("fid",e.file.fid),window.history.pushState(null,null,decodeURIComponent(a.href)),refreshModalContents()}showToast("File "+e.file.filename+c,"is-success"),"upload"!==g&&("string"==typeof(j=e.file).metadata||j.metadata instanceof String)&&(j.metadata=JSON.parse(j.metadata)),jQuery("#fq-menu-file-save-figure").find("i").removeClass("fa-spinner fa-pulse").addClass("fa-save"),jQuery("#fq-modal-save-confirm-btn").removeClass("is-loading"),"upload"!==g&&jQuery("#fq-modal-file").removeClass("is-active")})).fail((function(){jQuery("#fq-menu-file-save-figure").find("i").removeClass("fa-spinner fa-pulse").addClass("fa-save"),jQuery("#fq-modal-save-confirm-btn").removeClass("is-loading"),showToast("Error - file was not"+u,"is-danger")}))},showModalSpinner=()=>{console.log("show"),jQuery("#fq-loading-overlay").show()},hideModalSpinner=()=>{console.log("hide"),jQuery("#fq-loading-overlay").hide()},showSaveFigureAsDialog=()=>{if(j){var e=j.filename.replace(/\.[^/.]+$/,"");jQuery("#fq-modal-save-name-input").val(e),jQuery("#fq-modal-save-confirm-btn").prop("disabled",!1)}else jQuery("#fq-modal-save-name-input").val("");b="my",prepareFileModal("saveFigureAs"),refreshModalContents()},updateMarginsSpacingInputs=()=>{let e=a.configObj.curConfig.baseUnit;var t=q*y.mm,n=C*y.mm,i=w*y.mm,o=x*y.mm,r=k*y.mm,l=S*y.mm,s=Math.round(t/y[e]*100)/100,d=Math.round(n/y[e]*100)/100,c=Math.round(i/y[e]*100)/100,u=Math.round(o/y[e]*100)/100,f=Math.round(r/y[e]*100)/100,m=Math.round(l/y[e]*100)/100;jQuery(".margin-unit").html(e),jQuery("#fq-content-add-magin-left").val(s),jQuery("#fq-content-add-magin-top").val(d),jQuery("#fq-content-add-magin-right").val(c),jQuery("#fq-content-add-magin-bottom").val(u),jQuery("#fq-content-add-spacing-horizontal").val(f),jQuery("#fq-content-add-spacing-vertical").val(m)},prepareFileModal=(e,t=!0)=>{showModalSpinner();var a=[],n="";switch(jQuery(".fq-modal-file-tab").removeClass("is-active"),e){case"openFigure":a.hide=".modal-action-panel, .fq-modal-file-tab",a.reveal=".figure-open-panel, #fq-modal-file-tab-my, #fq-modal-file-tab-shared",a.disable="#fq-modal-files-open-figure-confirm",a.activate="#fq-modal-file-tab-my",n="Open figure",l="openFigure";break;case"saveFigure":break;case"saveFigureAs":a.hide=".modal-action-panel, .fq-modal-file-tab, #fq-modal-file-search-block, #fq-modal-file-tab-preselected",a.reveal=".file-save-panel, #fq-modal-file-tab-my, #fq-modal-file-tab-shared",a.disable="",a.activate="#fq-modal-file-tab-my",n="Save figure as",l="saveFigure";break;case"importLocalContent":a.hide=".modal-action-panel, .fq-modal-file-tab, #fq-modal-file-search-block, #fq-modal-file-tab-preselected, #fq-modal-file-tab-shared",a.reveal=".file-upload-panel, #fq-modal-file-tab-my",a.disable="#fq-modal-upload-confirm-btn",a.activate="#fq-modal-file-tab-my",n="Select destination folder in FiglinQ",l="upload",g="upload";break;case"addFiglinqContent":a.hide=".modal-action-panel, .fq-modal-file-tab, #fq-modal-file-tab-preselected",a.reveal=".content-add-panel, .content-add-options-panel, #fq-modal-file-search-block, #fq-modal-file-tab-my, #fq-modal-file-tab-shared",v&&(a.reveal+=", #fq-modal-file-tab-preselected"),a.disable="#fq-modal-add-confirm-btn",a.activate="#fq-modal-file-tab-my",n="Select content to add to this figure",l="addContent",updateMarginsSpacingInputs();break;case"addFiglinqPreselectedContent":a.hide=".modal-action-panel, #fq-modal-file-panel-breadcrumb",a.reveal=".content-add-panel, .content-add-options-panel, #fq-modal-file-tab-my, #fq-modal-file-tab-shared",a.disable="#fq-modal-add-confirm-btn",a.activate="#fq-modal-file-tab-preselected",n="Select content to add to this figure",l="addContent",updateMarginsSpacingInputs()}jQuery("#file-panel-heading").html(n),jQuery(a.hide).addClass("is-hidden"),jQuery(a.disable).prop("disabled",!0),jQuery(a.reveal).removeClass("is-hidden"),jQuery(a.activate).addClass("is-active"),t&&jQuery("#fq-modal-file").addClass("is-active")},getSvgeditFiletype=e=>{switch(e){case"external_image":return"image";case"plot":return"plot";default:return!1}},getPlotProp=(e,t,a)=>e.figure.layout.hasOwnProperty(t)?e.figure.layout[t]:e.figure.layout.template.layout.hasOwnProperty(t)?e.figure.layout.template.layout[t]:a;var R;jQuery(document).on("change","#fq-file-upload-input",(()=>{var e=!!jQuery("#fq-file-upload-input")[0].files.length&&jQuery("#fq-file-upload-input")[0].files[0].name;e?(jQuery("#fq-modal-upload-confirm-btn").prop("disabled",!1),jQuery("#fq-file-upload-input-label").html(e)):jQuery("#fq-modal-upload-confirm-btn").prop("disabled",!0)})),jQuery(document).on("click","#fq-modal-upload-confirm-btn",(e=>{if(e.target.blur(),!jQuery("#fq-file-upload-input")[0].files.length)return void showToast("Please select the file first!","is-warning");var t=jQuery("#fq-file-upload-world-readable").val(),a=jQuery("#fq-file-upload-input")[0].files[0];h=jQuery("#fq-file-upload-input-label").html(),g="upload";var n=new FormData;n.append("files",a),jQuery("#fq-modal-file").removeClass("is-active"),uploadFileToFiglinQ(n,"upload",t,!0,Q[b])})),jQuery(document).on("change","#fq-modal-export-format-select",(()=>{updateExportFormState()})),jQuery(document).on("change","#fq-doc-baseunit",(e=>{let t=a.configObj.curConfig.baseUnit,i=jQuery(e.target).val();var o=jQuery("#fq-doc-setup-width").val(),r=jQuery("#fq-doc-setup-height").val(),l=o.match(/\d+/)[0],s=r.match(/\d+/)[0],d=l*y[t],c=Math.round(d/y[i]*100)/100,u=s*y[t],f=Math.round(u/y[i]*100)/100;a.configObj.curConfig.baseUnit=i,n.setConfig(a.configObj.curConfig),a.updateCanvas(),jQuery("#fq-doc-setup-width").val(""+c+i),jQuery("#fq-doc-setup-height").val(""+f+i),jQuery("#fq-doc-size").val("")})),jQuery(document).on("change","#fq-doc-setup-width",(e=>{jQuery("#fq-doc-size").val("");var t=jQuery(e.target).val(),n=a.svgCanvas.getResolution(),i=t;a.svgCanvas.setResolution(i,n.h)})),jQuery(document).on("change","#fq-doc-setup-height",(e=>{jQuery("#fq-doc-size").val("");var t=jQuery(e.target).val(),n=a.svgCanvas.getResolution(),i=t;a.svgCanvas.setResolution(n.w,i)})),jQuery(document).on("change","#fq-doc-size",(e=>{var t,n,i=jQuery(e.target).val();if(i){const e=a.configObj.curConfig.baseUnit;var[t,n]=i.split("x");t=t/y[e]+e,n=n/y[e]+e,a.svgCanvas.setResolution(t,n),jQuery("#fq-doc-setup-width").val(t),jQuery("#fq-doc-setup-height").val(n)}})),jQuery(document).on("click","#fq-menu-file-export",(()=>{jQuery("#fq-modal-export").addClass("is-active")})),jQuery(document).on("click","#fq-menu-object-adjust",(()=>{jQuery("#fq-modal-adjust").addClass("is-active")})),jQuery(document).on("click",".fq-modal-export-quality",(e=>{const t=parseInt(jQuery(e.target).data("increment"));var a=parseInt(jQuery("#fq-modal-export-quality-input").val())+t;a>100&&(a=100),a<10&&(a=10),jQuery("#fq-modal-export-quality-input").val(a)})),jQuery(document).on("click","#fq-modal-btn-confirm-save-figure",(e=>{jQuery("#fq-modal-import-newfig").removeClass("is-active"),showSaveFigureAsDialog()})),jQuery(document).on("click",".navbar-dropdown .navbar-item",(e=>{e.target.blur(),jQuery(e.target).parents(".navbar-item.has-dropdown").removeClass("is-hoverable"),setTimeout((function(){jQuery(e.target).parents(".navbar-item.has-dropdown").addClass("is-hoverable")}),100)})),jQuery(document).on("click","#fq-menu-file-import-local-content",(()=>{b="my",prepareFileModal("importLocalContent"),refreshModalContents()})),jQuery(document).on("click","#fq-modal-adjust-btn-adjust",(async e=>{jQuery(e.currentTarget).addClass("is-loading"),await(async()=>{const e=jQuery("#fq-modal-export-property-select").val().split("-"),t=parseFloat(jQuery("#fq-modal-export-property-input").val()),a=n.getSelectedElems();let i=a.length,o=!1;if(i<1)alert("Please select at least one object!");else{for(;i--;){const n=a[i],r=jQuery(n).data("fid"),l=jQuery(n).hasClass("fq-plot"),d=jQuery(n).attr("href");if(!n||!l)continue;o=!0;const c=`${m}v2/plots/${r}/content`;await fetch(c,{method:"GET",mode:"cors",credentials:"include",headers:{"X-CSRFToken":s}}).then((e=>e.json())).then((a=>(setDeep(a,e,t,!0),a))).then((e=>{const t={figure:e};fetch(`${m}v2/plots/${r}`,{method:"PUT",mode:"cors",credentials:"include",headers:{"X-CSRFToken":s,Accept:"application/json","Content-Type":"application/json"},body:JSON.stringify(t)})})).then((e=>{const t={figure:e};fetch(`${m}v2/files/${r}`,{method:"PATCH",mode:"cors",credentials:"include",headers:{"X-CSRFToken":s,Accept:"application/json","Content-Type":"application/json"},body:JSON.stringify(t)}).then((()=>{fetch(d,{cache:"reload",mode:"cors",credentials:"include",headers:{"X-CSRFToken":s}}).then((()=>{jQuery(n).attr("href",d+"#"+(new Date).getTime())}))}))}))}!1===o&&alert("Please select at least one plot!")}})(),jQuery(e.currentTarget).removeClass("is-loading")})),jQuery(document).on("click","#fq-modal-export-btn-export",(async e=>{jQuery(e.currentTarget).addClass("is-loading"),g="download",d=jQuery("#fq-modal-export-format-select").val(),f=parseFloat(jQuery("#fq-modal-export-quality-input").val())/100,h=jQuery("#fq-modal-export-fname-input").val(),p="pdf"==d?jQuery("#fq-modal-export-size-select option:selected").text():parseInt(jQuery("#fq-modal-export-size-select").val()),await exportImageFromEditor(),jQuery(e.currentTarget).removeClass("is-loading")})),jQuery(document).on("focusout","#fq-modal-export-quality-input",(e=>{var t=parseInt(jQuery(e.target).val());t>100&&(t=100),t<10&&(t=10),isNaN(t)&&(t=80),jQuery(e.target).val(t)})),jQuery(document).on("click","#fq-menu-view-show-grid",(()=>{jQuery("#view_grid").click(),a.configObj.curConfig.showGrid?jQuery("#fq-menu-view-show-grid").find("i").removeClass("fa-square").addClass("fa-check-square"):jQuery("#fq-menu-view-show-grid").find("i").addClass("fa-square").removeClass("fa-check-square")})),jQuery(document).on("click","#fq-menu-view-show-rulers",(()=>{let e=a.configObj.curConfig.showRulers;e?jQuery("#fq-menu-view-show-rulers").find("i").addClass("fa-square").removeClass("fa-check-square"):jQuery("#fq-menu-view-show-rulers").find("i").removeClass("fa-square").addClass("fa-check-square"),a.configObj.curConfig.showRulers=!e,a.rulers.display(!e)})),jQuery(document).on("click","#fq-menu-file-document-properties",(()=>{jQuery("#fq-doc-size").val("");const e=a.configObj.curConfig.baseUnit,t=a.svgCanvas.getResolution();jQuery("#fq-doc-baseunit").val(e);const n=a.configObj.curConfig.gridSnapping,i=a.configObj.curConfig.snappingStep;jQuery("#fq-doc-setup-snapping-enabled").prop("checked",n),jQuery("#fq-doc-setup-snapping-step").val(i),jQuery("#fq-doc-setup-width").val(t.w/y[e]+e),jQuery("#fq-doc-setup-height").val(t.h/y[e]+e),jQuery("#fq-modal-doc-setup").addClass("is-active")})),jQuery(document).on("change","#fq-doc-setup-snapping-enabled",(e=>{const t=jQuery(e.target).prop("checked");a.configObj.curConfig.gridSnapping=t,n.setConfig(a.configObj.curConfig),a.updateCanvas()})),jQuery(document).on("keyup","#fq-doc-setup-snapping-step",(e=>{const t=parseInt(jQuery(e.target).val());a.configObj.curConfig.snappingStep=t,n.setConfig(a.configObj.curConfig),a.updateCanvas()})),jQuery(document).on("click","#fq-doc-setup-save-btn",(()=>{const e=jQuery("#fq-doc-size").val(),t=parseInt(jQuery("#fq-doc-setup-snapping-step").val()),i=jQuery("#fq-doc-setup-snapping-enabled").prop("checked"),o="fit"===e?"fit":jQuery("#fq-doc-setup-width").val(),r="fit"===e?"fit":jQuery("#fq-doc-setup-height").val(),l=jQuery("#fq-doc-baseunit").val();jQuery("#fq-modal-doc-setup").removeClass("is-active"),"fit"===o||isValidUnit("width",o)?"fit"===r||isValidUnit("height",r)?(n.setResolution(o,r)||showToast("No content to fit!","is-danger"),a.configObj.curConfig.baseUnit=l,a.configObj.curConfig.gridSnapping=i,a.configObj.curConfig.snappingStep=t,n.setConfig(a.configObj.curConfig),a.updateCanvas()):showToast("Invalid height unit!","is-danger"):showToast("Invalid width unit!","is-danger")})),jQuery(document).on("click",".fq-modal-cancel-btn",(()=>{jQuery(".modal").removeClass("is-active")})),jQuery(document).on("click",".fq-modal-file-tab",(e=>{if(showModalSpinner(),jQuery(".fq-modal-file-tab").removeClass("is-active"),jQuery("#fq-modal-add-confirm-btn, #col_select").prop("disabled",!0),jQuery(e.currentTarget).addClass("is-active"),"shared"==(b=jQuery(e.currentTarget).data("mode")))jQuery("#fq-modal-file-search-wrapper").prop("disabled",!0);else if("my"==b)jQuery("#fq-modal-file-search-wrapper").prop("disabled",!1);else if("preselected"==b)return jQuery("#fq-modal-file-search-wrapper").prop("disabled",!0),jQuery("#fq-modal-file-panel-breadcrumb").addClass("is-hidden"),void refreshModalContents(v.fids);Q={my:!1,shared:!1,preselected:!1},refreshModalContents()})),jQuery(document).on("click","#fq-modal-refresh-btn",(()=>{showModalSpinner(),refreshModalContents()})),jQuery(document).on("click",".fq-modal-plot-item, .fq-modal-image-item, .fq-modal-figure-item",(e=>{if("saveFigure"!==l){if("openFigure"===l)return jQuery(".fq-modal-plot-item, .fq-modal-image-item, .fq-modal-figure-item").removeClass("is-active"),jQuery(e.target).addClass("is-active"),void jQuery("#fq-modal-files-open-figure-confirm").prop("disabled",!1);jQuery(e.target).hasClass("is-active")?jQuery(e.target).removeClass("is-active"):jQuery(e.target).addClass("is-active");var t=!1,a=[];jQuery(".fq-modal-plot-item, .fq-modal-image-item, .fq-modal-figure-item").each((function(){jQuery(this).hasClass("is-active")&&(t=!0,a.push(jQuery(this).data("fid")))})),t?(jQuery("#fq-modal-add-confirm-btn").prop("disabled",!1),jQuery("#fq-modal-add-confirm-btn").data("selectedFid",a),a.length>1?jQuery("#col_select").prop("disabled",!1):jQuery("#col_select").prop("disabled",!0)):jQuery("#fq-modal-add-confirm-btn").prop("disabled",!0)}else if(jQuery(e.target).hasClass("fq-modal-figure-item")){jQuery(".fq-modal-plot-item, .fq-modal-image-item, .fq-modal-figure-item").removeClass("is-active"),jQuery(e.target).addClass("is-active");var n=jQuery(e.target).find(".fq-list-item-text").html();n.toLowerCase().endsWith(".svg")&&(n=n.replace(/\.[^/.]+$/,""),jQuery("#fq-modal-save-name-input").val(n),jQuery("#fq-modal-save-confirm-btn").prop("disabled",!1))}})),jQuery(document).on("click",".fq-modal-folder-item",(e=>{const t=jQuery(e.currentTarget).data("fid").toString(),a=jQuery(e.target).text().trim();Q[b]=t,updateBreadcrumb(t,a),i="",o="",updateItemList(t,1),jQuery("#fq-modal-add-confirm-btn").prop("disabled",!0),jQuery("#fq-modal-refresh-btn").addClass("is-loading")})),jQuery(document).on("click","#fq-menu-interact-switch",(e=>{e.target.blur(),jQuery("#fq-menu-interact-switch").is(":checked")?setInteractiveOn():setInteractiveOff()})),jQuery(document).on("click","#fq-modal-add-confirm-btn",(e=>{e.target.blur(),n.clearSelection(),jQuery(e.target).addClass("is-loading");const t=((e,t)=>jQuery(jQuery(e).toArray().sort(((e,a)=>parseInt(e.getAttribute(t))-parseInt(a.getAttribute(t))))))(".fq-modal-plot-item.is-active, .fq-modal-image-item.is-active, .fq-modal-figure-item.is-active","data-index"),i=parseInt(jQuery("#col_select").val());var o={left:parseFloat(jQuery("#fq-content-add-magin-left").val()),top:parseFloat(jQuery("#fq-content-add-magin-top").val()),right:parseFloat(jQuery("#fq-content-add-magin-right").val()),bottom:parseFloat(jQuery("#fq-content-add-magin-bottom").val())},r={horizontal:parseFloat(jQuery("#fq-content-add-spacing-horizontal").val()),vertical:parseFloat(jQuery("#fq-content-add-spacing-vertical").val())};let l=a.configObj.curConfig.baseUnit;"px"!==l&&(o.left=o.left*y[l],o.top=o.top*y[l],o.right=o.right*y[l],o.bottom=o.bottom*y[l],r.horizontal=r.horizontal*y[l],r.vertical=r.vertical*y[l]);var s=[];jQuery.each(t,(e=>{s[e]={fid:jQuery(t[e]).data("fid"),endpoint:"plot"==jQuery(t[e]).data("ftype")?"plots":"files"}}));var d=a.svgCanvas.getResolution(),f=s.map((function(e){return getFileDataFromFiglinQ(e.fid,e.endpoint)}));Promise.all(f).then((t=>{var l=400,s=360,f=!1;t.some(((e,a)=>{const n=parseFid(e.fid,0),i=parseFid(e.fid,1),o=`${m}~${n}/${i}.`;var r,d;"plot"==e.filetype?(r=getPlotProp(e,"width",l),d=getPlotProp(e,"height",s),!1===f&&(f=a,l=r,s=d),t[a].imgHref=o+"svg",t[a].svgeditFiletype="plot"):"external_image"==e.filetype&&(r=e.metadata.width,d=e.metadata.height,t[a].imgHref=o+"src",t[a].svgeditFiletype="image"),t[a].width=r||400,t[a].height=d||360,t[a].contentHref=o+"embed"}));var p=0,h=0,g=1;const y=d.w-o.right-o.left-r.horizontal*(i-1);var v=y;t.some((e=>{const t=((e,t,a,n,i)=>{var o={};return"width"===e?(o.width=n,o.height=Math.round(a*n/t)):"height"===e&&(o.width=Math.round(t*i/a),o.height=i),o})("height",e.width,e.height,l,s);e.widthScaled=t.width,e.heightScaled=t.height,p+=t.width,v=Math.max(v,p),(g+=1)>i&&(g=1,p=0,h+=s+r.vertical)}));const j=y/v,b=s*j;g=1,p=o.left,h=o.top;const Q=jQuery("#fq-add-panel-letters").val();t.some(((e,t)=>{e.widthScaled=e.widthScaled*j,e.heightScaled=e.heightScaled*j;var a={width:e.widthScaled,height:e.heightScaled,widthOriginal:e.width,heightOriginal:e.height,x:p,y:h,filetype:e.svgeditFiletype,fid:e.fid,contentHref:e.contentHref,imgHref:e.imgHref};if(placeElement(a),Q){let e=O[t];"lower"===Q&&(e=e.toLowerCase());((e,t="")=>{const a={element:"text",attr:e},i=new u("Insert text"),o=n.addSVGElementFromJson(a);o.textContent=t,i.addSubCommand(new c(o)),n.undoMgr.addCommandToHistory(i),n.call("changed",[o])})({x:p-6,y:h-6,id:n.getNextId(),fill:"#000000","stroke-width":"0","font-size":"14","font-family":"Sans-serif","text-anchor":"middle","xml:space":"preserve",opacity:1},e)}p+=e.widthScaled+r.horizontal,(g+=1)>i&&(g=1,p=o.left,h+=b+r.vertical)})),jQuery(e.target).removeClass("is-loading"),jQuery("#fq-modal-file").removeClass("is-active"),jQuery(document).unbind("keyup",closeModalOnEscape),setTimeout((function(){a.zoomChanged(window,"layer")}),500)}))})),jQuery(document).on("click","#fq-modal-file-search-icon.fa-times-circle",(e=>{jQuery("#fq-modal-file-search-input").val("").keyup()})),jQuery(document).on("keyup","#fq-modal-file-search-input",(e=>{refreshModalContents()})),jQuery(document).on("keyup","#fq-modal-save-name-input",(e=>{jQuery(e.target).val().length?jQuery("#fq-modal-save-confirm-btn").prop("disabled",!1):jQuery("#fq-modal-save-confirm-btn").prop("disabled",!0)})),jQuery(document).on("click","#fq-modal-files-open-figure-confirm",(()=>{jQuery("#fq-modal-file").removeClass("is-active"),jQuery(document).unbind("keyup",closeModalOnEscape),jQuery("#fq-modal-confirm-btn-ok").html("Open figure"),jQuery("#fq-modal-confirm").addClass("is-active");let e=jQuery(".fq-modal-figure-item.is-active").data("fid");setModalConfirmBtnHandler(openFigure,{fid:e})})),jQuery(document).on("click","#fq-menu-file-new-figure",(()=>{jQuery("#fq-modal-confirm-btn-ok").html("New figure"),setModalConfirmBtnHandler(onConfirmClear),jQuery("#fq-modal-confirm").addClass("is-active")})),jQuery(document).on("click","#fq-modal-save-confirm-btn",(async e=>{jQuery("#fq-modal-save-confirm-btn").addClass("is-loading"),e.target.blur(),g="thumb",d="png",h=jQuery("#fq-modal-save-name-input").val(),p=parseInt(jQuery("#fq-modal-export-size-select").val());const t=jQuery("#file_upload_world_readable").val();let a,n=!1;if(jQuery(".fq-modal-image-item, .fq-modal-figure-item").each((function(){jQuery(this).find(".fq-list-item-text").html()==h+".svg"&&(n=!0,a=jQuery(this).data("fid"))})),n&&!confirm("File already exists. Overwrite?"))return void jQuery("#fq-modal-save-confirm-btn").removeClass("is-loading");if("shared:-1"===Q[b])return void showToast("Please select one of the shared folders!","is-danger");const i=getSvgFromEditor();var o=new Blob([i],{type:"image/svg+xml"}),r=new File([o],h+".svg"),l=await exportImageFromEditor(),s=new File([l],h+"_thumb.png"),c=new FormData;c.append("files",r),c.append("thumb",s);const u=jQuery(".fq-image, .fq-plot, .fq-figure").length>0;var f=j?j.metadata:{};f.svgedit=f.svgedit||{},f.svgedit.haslinkedcontent=!!u,c.append("metadata",JSON.stringify(f)),n&&c.append("replaced_fid",a),uploadFileToFiglinQ(c,"upload",t,!0,Q[b])})),jQuery(document).on("change","#zoom",(e=>{const t=jQuery(e.target).val();switch(t){case"default":return;case"canvas":case"selection":case"layer":case"content":a.zoomChanged(window,t);break;default:{const e=Number(t)/100;if(e<.001)return void(t=.1);const i=n.getZoom(),{workarea:o}=a;a.zoomChanged(window,{width:0,height:0,x:(o.scrollLeft+parseFloat(getComputedStyle(o,null).width.replace("px",""))/2)/i,y:(o.scrollTop+parseFloat(getComputedStyle(o,null).height.replace("px",""))/2)/i,zoom:e},!0)}}jQuery(e.target).val("default")})),jQuery(document).on("click",".fq-menu-add-content-btn",(()=>{setInteractiveOff(),prepareFileModal("addFiglinqContent"),b="my",refreshModalContents()})),jQuery(document).on("click","#fq-menu-file-save-figure",(async e=>{if(setInteractiveOff(),!j)return void showSaveFigureAsDialog();jQuery("#fq-menu-file-save-figure").find("i").removeClass("fa-save").addClass("fa-spinner fa-pulse"),e.target.blur(),g="thumb",d="png",h=j.filename,Q[b]=parseFid(j.fid,0)+":"+j.parent;const t=j.world_readable,a=j.fid,n=getSvgFromEditor(),i=new Blob([n],{type:"image/svg+xml"}),o=new File([i],h+".svg"),r=await exportImageFromEditor(),l=new File([r],h+"_thumb.svg");var s=new FormData;s.append("files",o),s.append("thumb",l),s.append("replaced_fid",a);const c=jQuery(".fq-image, .fq-plot, .fq-figure").length>0;var u=j.metadata||{};u.svgedit=u.svgedit||{},u.svgedit.haslinkedcontent=!!c,s.append("metadata",JSON.stringify(u)),uploadFileToFiglinQ(s,"upload",t,!1,Q[b])})),jQuery(document).on("click","#fq-menu-file-save-figure-as",(()=>{setInteractiveOff(),showSaveFigureAsDialog()})),jQuery(document).on("click",".navbar-burger",(()=>{jQuery(".navbar-burger").toggleClass("is-active"),jQuery(".navbar-menu").toggleClass("is-active")})),jQuery(document).on("keyup",".fq-margin-input",(e=>{!0===jQuery("#fq-content-add-link-margins").prop("checked")&&jQuery(".fq-margin-input").val(jQuery(e.target).val())})),jQuery(document).on("click","#fq-menu-file-open-figure",(()=>{prepareFileModal("openFigure"),refreshModalContents()})),(()=>{const e=document.createElementNS(P,"svg");document.body.append(e);const t=document.createElementNS(P,"rect");t.setAttribute("width","1em"),t.setAttribute("height","1ex"),t.setAttribute("x","1in"),e.append(t);const a=t.getBBox();e.remove();const n=a.x;y={em:a.width,ex:a.height,in:n,cm:n/2.54,mm:n/25.4,pt:n/72,pc:n/6,px:1,"%":0}})(),a.configObj.curConfig.showGrid?jQuery("#fq-menu-view-show-grid").find("i").removeClass("fa-square").addClass("fa-check-square"):jQuery("#fq-menu-view-show-grid").find("i").addClass("fa-square").removeClass("fa-check-square"),a.configObj.curConfig.showRulers?jQuery("#fq-menu-view-show-rulers").find("i").removeClass("fa-square").addClass("fa-check-square"):jQuery("#fq-menu-view-show-rulers").find("i").addClass("fa-square").removeClass("fa-check-square"),jQuery.ajax({url:m+"v2/users/current",xhrFields:{withCredentials:!0}}).done((function(e){e.username?(jQuery("#fq-menu-login-btn").addClass("is-hidden"),jQuery("#fq-menu-signup-btn").addClass("is-hidden"),jQuery(".fq-menu-add-content-btn").removeClass("is-hidden"),jQuery("#fq-menu-interact-switch-item").removeClass("is-hidden"),jQuery("#fq-menu-file-open-figure").removeClass("is-hidden"),jQuery("#fq-menu-file-save-figure").removeClass("is-hidden"),jQuery("#fq-menu-file-save-figure-as").removeClass("is-hidden"),jQuery("#fq-menu-file-import-local-content").removeClass("is-hidden"),jQuery("#fq-breadcrumb-item-home").data("fid",`${e.username}:-1`).find(".fq-modal-folder-item").data("fid",`${e.username}:-1`),r=e.username,jQuery("#fq-menu-account-user-name").html(r.slice(0,2)),jQuery("#fq-menu-account-dropdown-user-name").html(r),jQuery("#fq-menu-account-navbar-item1").removeClass("is-hidden"),jQuery("#fq-menu-account-navbar-item2").removeClass("is-hidden"),jQuery("#fq-user-link-files").attr("href",m+"organize/home"),jQuery("#fq-user-link-charts").attr("href",m+"create"),jQuery("#fq-user-link-figures").attr("href",m+"figures"),jQuery("#fq-user-link-collections").attr("href",m+"dashboard/create"),jQuery("#fq-menu-account-sign-out").attr("href",m+"signout"),jQuery("#fq-menu-account-settings").attr("href",m+"settings/profile"),s=e.csrf_token):showToast("It looks like you are not logged in to FiglinQ in this browser!","is-danger")})).fail((function(){jQuery("#fq-menu-login-btn").removeClass("is-hidden"),jQuery("#fq-menu-signup-btn").removeClass("is-hidden"),jQuery(".fq-menu-add-content-btn").addClass("is-hidden"),jQuery(".fq-menu-add-content-btn").addClass("is-hidden"),jQuery(".fq-menu-add-content-btn").addClass("is-hidden"),jQuery(".fq-menu-add-content-btn").addClass("is-hidden"),showToast("Could not connect to FiglinQ - are you logged in?","is-danger")})),setInteractiveOff(),jQuery("#zoom").replaceWith('        \n          <div id="zoom" class="select is-small" title="Hold shift while scrolling your mouse to zoom dynamically">\n            <select>\n              <option value="default">Zoom level</option>\n              <option value="1000">1000</option>\n              <option value="400">400</option>\n              <option value="200">200</option>\n              <option value="100">100</option>\n              <option value="50">50</option>\n              <option value="25">25</option>\n              <option value="canvas">Fit to canvas</option>\n              <option value="selection">Fit to selection</option>\n              <option value="layer">Fit to content</option>\n            </select>\n          </div>'),jQuery("#image_url").hide(),["selected_x","selected_y","rect_width","rect_height","path_node_x","path_node_y","starNumPoints","RadiusMultiplier","radialShift","ellipse_cx","ellipse_cy","ellipse_rx","ellipse_ry","circle_cx","circle_cy","circle_r","line_x1","line_x2","line_y1","line_y2","polySides","image_width","image_height"].forEach((e=>{(R=document.createElement("style")).innerHTML="#label{ top: 4px; margin-right: 2px; margin-left: 2px; font-size: 12px; text-transform: capitalize;} #label:after{ content: ':' }",document.getElementById(e).shadowRoot.appendChild(R)})),(R=document.createElement("style")).innerHTML="elix-dropdown-list{ margin-left: 4px; margin-right: 4px} elix-dropdown-list:hover{ cursor: pointer; }",document.getElementById("tool_position").shadowRoot.appendChild(R),(R=document.createElement("style")).innerHTML=".menu-item{background-color: var(--main-bg-color); color: white; text-transform: capitalize;} .menu-item:hover{ cursor: pointer; } .image-lib{background-color: var(--main-bg-color)}",document.getElementById("tool_shapelib").shadowRoot.appendChild(R),["seg_type","tool_font_family"].forEach((e=>{(R=document.createElement("style")).innerHTML="select{margin-top: 10px; margin-right: 4px; border: none; border-radius: 3px; cursor: pointer;} .menu-item:hover{ cursor: pointer; }",document.getElementById(e).shadowRoot.appendChild(R)})),(()=>{const e=F("fid"),t=F("add");if(e)n.clear(),openFigure({data:{fid:e}});else if(t){const e=t.split(",");jQuery("#fq-menu-interact-switch").is(":checked")&&jQuery("#fq-menu-interact-switch").click(),b="preselected",showModalSpinner(),prepareFileModal("addFiglinqPreselectedContent"),refreshModalContents(e)}})(),updateExportFormState()}}}};export{p as default};
//# sourceMappingURL=ext-figlinq.js.map
